require("buttons")
require("level")
require("player")
screenWidth = love.graphics.getWidth()
screenHeight = love.graphics.getHeight()
love.filesystem.setIdentity("zelda ripoff")
--
mouseover_button = false
mouseover_button_type = 0
--
autopause = true
ismoving = false
draw_warning = false
printdt=""
--
start_x = 0
start_y = 0
--
function love.load()
	
	--preload
	print("Loading...")
	--
	min_dt = 1/60
	next_time = love.timer.getTime()
	
	love.graphics.setBackgroundColor(255,255,255)
	--
	loaded = true
	print("Loading complete!")
	--
	buttons.invoke(50, 60, 1)
	buttons.invoke(50, 100, 2)
end

--global funcs
function CheckCollision(x1,y1,w1,h1,x2,y2,w2,h2)
	return x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1;
end
--save config
function saveConfig(w, h, vsync_flag)
	local string test = ""
	local read_config_save = {}
	for line in love.filesystem.lines("save.zr") do
		table.insert(read_config_save, line)
	end
	read_config_save[1] = w * 1337
	read_config_save[2] = h * 1337
	read_config_save[3] = vsync_flag
	for i,v in ipairs(read_config_save) do
		test = test .. tostring(read_config_save[i]) .. "\n"
	end
	success = love.filesystem.write("save.zr", test, all)
end
--
function applyConfig(w, h, vsync_flag)
	local vsync_flag_bool = false
	if vsync_flag == '0' then
		vsync_flag_bool = false
	else
		vsync_flag_bool = true
	end
	love.window.setMode(w, h, {resizable=false, vsync=vsync_flag_bool})
end

--mouse pressed
function love.mousepressed(x, y, button)
	
	
	
end
--mouse released
function love.mousereleased(x, y, button)
	
end


--key pressed
function love.keypressed(key)
	if key == 'p' then
		if draw_menu then
			draw_menu = false
			paused = false
		else
			draw_menu = true
			paused = true
		end
	end
	
	if key == 'm' then
		level.clear(level_draw)
		level.clear(level_exit)
		level.clear(player_draw)
		level.invoke(1)
		player.spawn(start_x, start_y)
		direction2 = ""
		direction = ""
	end
end
--key released
function love.keyreleased(key) 

end


--UPDATE
function love.update(dt)
printdt = dt
	next_time = next_time + min_dt
	if loaded then
		level.update(dt)
		UPDATE_BUTTONS(dt)
		player.physics(dt)
		player.update(dt)
		player.boundary()
		player.move(dt)
		
		
		
	end
end


--DRAW
function love.draw()
	
	level.draw()
	player.draw()
	love.graphics.setColor(0,0,0)
	love.graphics.print("FPS: "..tostring(love.timer.getFPS()), 750, 5)
	local cur_time = love.timer.getTime()
	if next_time <= cur_time then
		next_time = cur_time
		return
	end
	love.timer.sleep(next_time - cur_time)
	love.graphics.setColor(0,0,0)
	love.graphics.print("xvel: "..player.xvel, 650, 40)
	love.graphics.print("yvel: "..player.yvel, 650, 55)
	love.graphics.print("dt: "..printdt, 650, 70)

	
	if loaded then
		if draw_menu then
			love.graphics.setColor(0,0,0, 180)
			love.graphics.rectangle("fill",0,0, 800, 600)
			DRAW_BUTTONS()
		end
	end
end
--FOCUS
function love.focus(bool)
	if not bool and autopause then
		draw_menu = true
		paused = true
	else
		paused = false
	end
end

