player = {}
player.x = 0
player.y = 0
player.height = 24
player.width = 24
player.image = love.graphics.newImage("textures/player/player.png")
player_draw = {}
player.xvel = 0
player.yvel = 0
player.friction = 9.5
player.speed = 2000
direction = ""
collision_detected = false

function player.spawn(x, y)
	player.x = x
	player.y = y
	table.insert(player_draw, {x = player.x, y = player.y, image = player.image})
end
--
function player.draw()
	for i,v in ipairs(player_draw) do
		love.graphics.setColor(255,255,255)
		--love.graphics.draw(player.image, player.x, player.y)
		love.graphics.rectangle("fill", player.x, player.y, player.height, player.width)
	end
end
--
function player.physics(dt)
	if player.xvel > 4 or player.xvel < 4 then 
		for i,lev in ipairs(level_draw) do
			if CheckCollision(player.x + (player.xvel * dt)*3, player.y + (player.yvel * dt)*3, player.height, player.width, lev.x, lev.y, level.tile_h, level.tile_w) then
				if lev.tile_id == '1' then
					player.xvel = 0
				end
			end
		end
	end
	
	if player.yvel > 4 or player.yvel < 4 then 
		for i,lev in ipairs(level_draw) do
			if CheckCollision(player.x + (player.xvel * dt)*3, player.y + (player.yvel * dt)*3, player.height, player.width, lev.x, lev.y, level.tile_h, level.tile_w) then
				if lev.tile_id == '1' then
					player.yvel = 0
				end
			end
		end
	end
	
	
	player.xvel = player.xvel * (1 - math.min(dt*player.friction, 1))
	player.yvel = player.yvel * (1 - math.min(dt*player.friction, 1))
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	
end
--
function player.boundary()
	if player.x < 0 then
		player.x = 0
		player.xvel = 0
	end
	
	if player.y < 0 then
		player.y = 0
		player.yvel = 0
	end
	if player.x + player.width > 576 then
		player.x = 576 - player.width
		player.xvel = 0
	end
	if player.y + player.height > 576 then
		player.y = 576 - player.height
		player.yvel = 0
	end
end
--
function player.move(dt)

	--X axis
	if love.keyboard.isDown('d') and player.xvel < player.speed then
		player.xvel = player.xvel + player.speed * dt
		for i,lev in ipairs(level_draw) do
			if CheckCollision(player.x + (player.xvel * dt)*3, player.y + (player.yvel * dt)*3, player.height, player.width, lev.x, lev.y, level.tile_h, level.tile_w) then
				if lev.tile_id == '1' then
					player.xvel = 0
				end
			end
		end
	end
	
	if love.keyboard.isDown('a') and player.xvel > -player.speed then
		player.xvel = player.xvel - player.speed * dt
		for i,lev in ipairs(level_draw) do
			if CheckCollision(player.x + (player.xvel * dt)*3, player.y + (player.yvel * dt)*3, player.height, player.width, lev.x, lev.y, level.tile_h, level.tile_w) then
				if lev.tile_id == '1' then
					player.xvel = 0
				end
			end
		end
	end
	
	--Y axis
	if love.keyboard.isDown('w') and player.yvel > -player.speed then
		player.yvel = player.yvel - player.speed * dt
		for i,lev in ipairs(level_draw) do
			if CheckCollision(player.x + (player.xvel * dt)*3, player.y + (player.yvel * dt)*3, player.height, player.width, lev.x, lev.y, level.tile_h, level.tile_w) then
				if lev.tile_id == '1' then
					player.yvel = 0
				end
			end
		end
	end
	
	if love.keyboard.isDown('s') and player.yvel > -player.speed then
		player.yvel = player.yvel + player.speed * dt
		for i,lev in ipairs(level_draw) do
			if CheckCollision(player.x + (player.xvel * dt)*3, player.y + (player.yvel * dt)*3, player.height, player.width, lev.x, lev.y, level.tile_h, level.tile_w) then
				if lev.tile_id == '1' then
					player.yvel = 0
				end
			end
		end
	end
	
	
end
--
function player.update(dt)
	player.physics(dt)
end

